#!/bin/sh

#ver 2.0.9s,hbchen 2011-05-26
#add support upgrade /var/ann/ by upgrade and advance_upgrade

#ver 2.0.9r,hbchen 2009-12-29
#fix bz2 and gz exist problem for autoupd and boa
#add advanced upgrade
#add flash space check
#add filter autoupd and boa
#add filter boa.conf and outconfig.ini

DIR=/tmp/tmp999/
DDIR=/
FILE=
FILENAME=
CURDIR=
TDIR=
CURDIR2=
TDIR2=
CURDIR3=
TDIR3=
FLAG=0
FILESIZE=0
TOTALNEWSIZE=0
TOTALOLDSIZE=0
FREE=0
OFSIZE=0
RETVAL=1

check_space() {

FREE=`df |grep mnt | sed s/" *[0-9]\{1,3\}%.*$"// | sed s/"^.* "//`

if [ -d $DIR/var/bin ]
then
   for loop in `ls $DIR/var/bin`
   do
        #get new file size
#        FILESIZE=`ls -s $DIR/var/bin/$loop | sed s/"^ *"// | sed s/" .*$"//`
        FILESIZE=`ls -l $DIR/var/bin/$loop | sed s/" [A-Z].*$"// | sed s/"^.* "//`
        TOTALNEWSIZE=`expr $TOTALNEWSIZE + $FILESIZE`;

        #get old file size
        FILENAME=`echo $loop |sed s/"\.".*/".*"/`
#        FILESIZE=`ls -s $DDIR/var/bin/$FILENAME | sed s/"^ *"// | sed s/" .*$"//`
        FILESIZE=`ls -l $DDIR/var/bin/$FILENAME | sed s/" [A-Z].*$"// | sed s/"^.* "//`
        OFSIZE=0;
        for size in $FILESIZE
        do
                OFSIZE=`expr $OFSIZE + $size`;
        done
        TOTALOLDSIZE=`expr $TOTALOLDSIZE + $OFSIZE`;
   done

#   echo $TOTALOLDSIZE $TOTALNEWSIZE;
   if [ $FREE -gt 50 ]
   then
	FREE=`expr $FREE - 50`
	FREE=`expr $FREE \* 1000`
   	FREE=`expr $FREE + $TOTALOLDSIZE`
#   echo free space $FREE
   else
	FREE=$TOTALOLDSIZE
   fi

#  echo "totalnewsize=$TOTALNEWSIZE free=$FREE" >> /var/log/messages
   if [ $TOTALNEWSIZE -gt $FREE ]
   then
        RETVAL=0;
   fi

fi

return $RETVAL
}



upgrade() {
for loop in `ls $DIR`
do
	if [ -d $DIR$loop ]
	then
		CURDIR=$DIR$loop/
		TDIR=$DDIR$loop/
		for r in `ls $DIR$loop`
  		do
		  if [ -d $DIR$loop/$r ]
        	  then
	                CURDIR2=$DIR$loop/$r/
        	        TDIR2=$DDIR$loop/$r/
			if [ ! -d $TDIR2 ]
			then
				rm -rf $TDIR2
				mkdir $TDIR2
			fi
			if [ $CURDIR2 = "/tmp/tmp999/var/ann/" ]
                        then
				rm -rf $TDIR2/*
			fi
			for r2 in `ls $DIR$loop/$r`
			do 
			  if [ $CURDIR2 = "/tmp/tmp999/var/bin/" ]
			  then
				FILENAME=`echo $r2 |sed s/"\.".*/".*"/`
				if [ "$FILENAME" != "autoupd" -a "$FILENAME" != "autoupd.*" -a "$FILENAME" != "autoflag" -a "$FILENAME" != "boa.*" ]
                                then
				  	rm -rf $TDIR2$FILENAME
					cp -rf $CURDIR2$r2 $TDIR2
				fi
			  elif [ $CURDIR2 = "/tmp/tmp999/var/pbx/" ]
			  then
				cp -rf $CURDIR2$r2 $TDIR2
			  elif [ $CURDIR2 = "/tmp/tmp999/var/ann/" ]
                          then
                                cp -rf $CURDIR2$r2 $TDIR2
			  elif [ $CURDIR2 = "/tmp/tmp999/var/config/" ]
			  then
				if [ $FLAG -lt 2 ]
				then
		  		if [ "$r2" != "app.ini" -a "$r2" != "autoupd.ini" -a "$r2" != "boa.conf" -a "$r2" != "outconfig.ini" ]
				  	then
					    if [ -d $CURDIR2$r2 ]
					    then
						CURDIR3=$DIR$loop/$r/$r2/
                        			TDIR3=$DDIR$loop/$r/$r2/
						if [ ! -d $TDIR3 ]
						then
							rm -rf $TDIR3
							mkdir $TDIR3
						fi 
			                        for r3 in `ls $DIR$loop/$r/$r2`
						do
							if [ -f $CURDIR3$r3 ]
							then
							 FILENAME=$r3
	                                                 tr -s '[\015\032]' '[\n]' < $CURDIR3$r3 >$CURDIR3$r3.tmp
							 mv -f $CURDIR3$r3.tmp $TDIR3$r3
							else
							  FILENAME=$r3
							  cp -rf $CURDIR3$r3 $TDIR3
							fi
						done
					    else
					    	FILENAME=$r2
						tr -s '[\015\032]' '[\n]' < $CURDIR2$r2 >$CURDIR2$r2.tmp
		                                mv -f $CURDIR2$r2.tmp $TDIR2$r2
					    fi
					fi
			  	elif [ -d $CURDIR2$r2 ]
				then
					CURDIR3=$DIR$loop/$r/$r2/
                                        TDIR3=$DDIR$loop/$r/$r2/
					if [ ! -d $TDIR3 ]
                                        then
                                                rm -rf $TDIR3
                                                mkdir $TDIR3
                                        fi

                                        for r3 in `ls $DIR$loop/$r/$r2`
                                        do
                                            if [ -f $CURDIR3$r3 ]
                                            then
                                            	FILENAME=$r3
                                                tr -s '[\015\032]' '[\n]' < $CURDIR3$r3 >$CURDIR3$r3.tmp
                                                mv -f $CURDIR3$r3.tmp $TDIR3$r3
                                            else
                                                FILENAME=$r3
                                                cp -rf $CURDIR3$r3 $TDIR3
                                            fi
                                        done
				else
		  			if [ "$r2" != "boa.conf" -a "$r2" != "outconfig.ini" ]
					then
				  		FILENAME=$r2
						tr -s '[\015\032]' '[\n]' < $CURDIR2$r2 >$CURDIR2$r2.tmp
					        mv -f $CURDIR2$r2.tmp $TDIR2$r2
					fi
				fi
			  fi
		       done
		  fi
		done
	fi
done
chmod 700 -R /var/bin/
rm -rf /tmp/tmp999
}

#advanced upgrade
advanced_upgrade() {

#rm all files in /var/bin except auto*
for dfile in `ls /var/bin`
do
	FILENAME=`echo $dfile |sed s/"\.".*/".*"/`
        if [ "$FILENAME" != "autoupd" -a "$FILENAME" != "autoupd.*" -a "$FILENAME" != "autoflag" -a "$FILENAME" != "boa.*" ]
        then
		rm -rf /var/bin/$FILENAME
	fi
done

for loop in `ls $DIR`
do
        if [ -d $DIR$loop ]
        then
                CURDIR=$DIR$loop/
                TDIR=$DDIR$loop/
                for r in `ls $DIR$loop`
                do
                  if [ -d $DIR$loop/$r ]
                  then
                        CURDIR2=$DIR$loop/$r/
                        TDIR2=$DDIR$loop/$r/
			if [ ! -d $TDIR2 ]
                        then
                                rm -rf $TDIR2
                                mkdir $TDIR2
                        fi

			if [ $CURDIR2 = "/tmp/tmp999/var/ann/" ]
                        then
				rm -rf $TDIR2/*
			fi
                        for r2 in `ls $DIR$loop/$r`
                        do
                          if [ -d $DIR$loop/$r/$r2 ]
                          then
                                cp -rf $CURDIR2$r2 $TDIR2
                          else
                                if [ $CURDIR2 = "/tmp/tmp999/var/bin/" ]
                                then
                                        FILENAME=`echo $r2 |sed s/"\.".*/".*"/`
                                        if [ "$FILENAME" != "autoupd" -a "$FILENAME" != "autoupd.*" -a "$FILENAME" != "autoflag" -a "$FILENAME" != "boa.*" ]
                                        then
                                                cp -f $CURDIR2$r2 $TDIR2
                                        else
						if [ "$FILENAME" != "autoflag" ]
						then
	                                                cp -f $CURDIR2$r2 $TDIR2$r2.new
        	                                        mv -f $TDIR2$r2.new $TDIR2$r2
							if [ "$r2" = "autoupd.bz2" ]
							then
								rm -f /var/bin/autoupd.gz /var/bin/autoupd
							fi
							if [ "$r2" = "autoupd.gz" ]
                                                        then
                                                                rm -f /var/bin/autoupd.bz2 /var/bin/autoupd
                                                        fi
							if [ "$r2" = "autoupd" ]
							then
                                                                rm -f /var/bin/autoupd.bz2 /var/bin/autoupd.gz
                                                        fi
							if [ "$r2" = "boa.bz2" ]
                                                        then
                                                                rm -f /var/bin/boa.gz
                                                        fi
							if [ "$r2" = "boa.gz" ]
                                                        then
                                                                rm -f /var/bin/boa.bz2
                                                        fi
						fi
                                        fi
				elif [ $CURDIR2 = "/tmp/tmp999/var/config/" ]
				then
					if [ "$r2" != "boa.conf" -a "$r2" != "outconfig.ini" ]
                                        then
						cp -rf $CURDIR2$r2 $TDIR2
					else	
						cp -f $CURDIR2$r2 $TDIR2$r2.new
        	                                mv -f $TDIR2$r2.new $TDIR2$r2
					fi
				elif [ $CURDIR = "/tmp/tmp999/etc/" ]
				then
					cp -f $CURDIR2$r2 $TDIR2$r2.new
                                        mv -f $TDIR2$r2.new $TDIR2$r2	
                                else
                                        cp -rf $CURDIR2$r2 $TDIR2
                                fi
                          fi
                        done
                   else
                        if [ $CURDIR = "/tmp/tmp999/etc/" ]
                        then
                                cp -f $CURDIR$r $TDIR$r.new
                                mv -f $TDIR$r.new $TDIR$r
                        else
                                cp -rf $CURDIR$r $TDIR$r
                        fi
                  fi
              done
        fi
done
chmod 700 -R /var/bin/
chmod 700 -R /etc/
rm -rf /tmp/tmp999
}


#read orig autoflag
read FLAG < /var/bin/autoflag
#echo $FLAG

if [ $FLAG -eq 8 ]
then
        echo "0" > /var/bin/autoflag
        advanced_upgrade;
elif [ $FLAG -eq 9 ]
then
        echo "5" > /var/bin/autoflag
        advanced_upgrade;
else
	check_space;
	if [ $RETVAL -eq 0 ]
	then
		#not enough space,stop upgrade
		echo "AutoProvision: upgrade firm error,not enough free space!" >> /var/log/messages
		echo 4 > /var/bin/autoflag
		rm -rf /tmp/tmp999
		exit;
	fi
	
	if [ $FLAG -lt 2 ]
	then
        	upgrade;
	else
        	#start really copy
	        echo "5" > /var/bin/autoflag
        	upgrade;
	fi
fi
